<?php
if (function_exists('register_sidebar')) register_sidebar();


// Set default values
if (get_option('mandigo_scheme')) { $current = get_option('mandigo_scheme'); }
else { $current = 'blue'; update_option('mandigo_scheme', $current); }

if (get_option('mandigo_headoverlay')) { $headoverlay = get_option('mandigo_headoverlay'); }
else { $headoverlay = 0; update_option('mandigo_headoverlay', $headoverlay); }

if (get_option('mandigo_dates')) { $dates = get_option('mandigo_dates'); }
else { $dates = 0; update_option('mandigo_dates', $dates); }

if (get_option('mandigo_bgcolor')) { $bgcolor = get_option('mandigo_bgcolor'); }
else { $bgcolor = '#44484F'; update_option('mandigo_bgcolor', $bgcolor); }

add_action('wp_head', 'mandigo_head');
function mandigo_head() {
$current = get_option('mandigo_scheme');
echo '<link rel="stylesheet" href="'. get_bloginfo('stylesheet_directory') .'/'. $current .'.css" type="text/css" media="screen" />
';
}



// SEARCH WIDGET
function widget_mandigo_search() {
?>
			<li><h2>Suche</h2>
				<?php include (TEMPLATEPATH . '/searchform.php'); ?>
			</li>
<?php
}
if (function_exists('register_sidebar_widget')) register_sidebar_widget(__('Search'),'widget_mandigo_search');




// CALENDAR WIDGET
function widget_mandigo_calendar() {
?>
			<li><h2>&nbsp;</h2>
				<?php get_calendar(); ?>
			</li>
<?php
}
if (function_exists('register_sidebar_widget')) register_sidebar_widget(__('Calendar'),'widget_mandigo_calendar');




// META WIDGET
function widget_mandigo_meta() {
$options = get_option('widget_meta');
$title = empty($options['title']) ? __('Meta') : $options['title'];
?>
				<li><h2><?php echo $title; ?></h2>
                                <span id="rss"><a href="feed:<?php bloginfo('rss2_url'); ?>" title="RSS feed for <?php bloginfo('name'); ?>"><img src="<?php echo bloginfo('stylesheet_directory'); ?>/images/<?php echo get_option('mandigo_scheme'); ?>/rss_l.gif" alt="Entries (RSS)" id="rssicon" onmouseover="hover(1,'rssicon','rss_l')" onmouseout="hover(0,'rssicon','rss_l')" /></a></span>
				<ul>
					<?php wp_register(); ?>
					<li><?php wp_loginout(); ?></li>
					<li><a href="http://wordpress.org/" title="Powered by WordPress, state-of-the-art semantic personal publishing platform.">WordPress</a></li>
					<li><a href="http://www.onehertz.com/portfolio/wordpress/" title="Other Wordpress themes by the same author" target="_blank">Mandigo theme</a></li>
					<?php wp_meta(); ?>
				</ul>
				</li>
<?php
}
if (function_exists('register_sidebar_widget')) register_sidebar_widget(__('Meta'),'widget_mandigo_meta');




// ADMIN
add_action('admin_menu', 'add_mandigo_options_page');
add_action('admin_menu', 'add_mandigo_readme_page');
function add_mandigo_options_page() { add_theme_page('Theme Options', 'Theme Options', 'edit_themes', basename(__FILE__), 'mandigo_options_page'); }
function add_mandigo_readme_page()  { add_theme_page('README', 'README', 'switch_themes', '', 'mandigo_readme_page'); }
function mandigo_set_scheme($var)        { update_option('mandigo_scheme',        $var); }
function mandigo_set_overlay($var)       { update_option('mandigo_headoverlay',   $var); }
function mandigo_set_dates($var)         { update_option('mandigo_dates',         $var); }
function mandigo_set_exclude_pages($var) { update_option('mandigo_exclude_pages', $var); }
function mandigo_set_bold_links($var)    { update_option('mandigo_bold_links',    $var); }
function mandigo_set_bgcolor($var)       {
	if (!preg_match("/^#?[0-9A-F]{6}$/i",$var)) { $var = '#44484F'; }
        if (!preg_match("/^#/",$var)) { $var = '#'. $var; }
	update_option('mandigo_bgcolor',$var);
}

function mandigo_options_page() {
	if ( $_GET['page'] == basename(__FILE__) ) {
		$ct = current_theme_info();

		if (isset($_POST['changedscheme'])) {
			mandigo_set_scheme($_POST['scheme']);
			mandigo_set_overlay($_POST['headoverlay']);
			mandigo_set_dates($_POST['dates']);
			$exclude[] = '';
			foreach ( $_POST as $field => $value ) {
				if ( preg_match("/exclude_(\d+)/",$field,$id) ) { $exclude[] = $id[1]; }
			}
			mandigo_set_exclude_pages(implode(",",$exclude));
			mandigo_set_bold_links($_POST['boldlinks']);
			mandigo_set_bgcolor($_POST['bgcolor']);
		}
		$current     = get_option('mandigo_scheme');
		$headoverlay = get_option('mandigo_headoverlay');
		$dates       = get_option('mandigo_dates');
		$exclude     = split(",",get_option('mandigo_exclude_pages'));
		$boldlinks   = get_option('mandigo_bold_links');
		$bgcolor     = get_option('mandigo_bgcolor');

		$pages = & get_pages('sort_column=menu_order');
		foreach ( $pages as $page ) {
			if (!$page->post_parent) { $pages_select .= '<input type="checkbox" name="exclude_'. $page->ID .'"'. (array_search($page->ID, $exclude) ? ' checked' : '') .' /> '. $page->post_title . '<br />'; }
		}

		echo '
		<p align="center"><a href="#versioncheck">Are you using the latest version?</a></p>
		<div class="wrap">
		<h2>'.__('Mandigo Options','mandigo').'</h2>

		<form name="mandigo_options_form" method="post" action="?page=functions.php">
		<input type="hidden" name="changedscheme" id="changedscheme" value="1" />

		<fieldset class="options">
		<legend>Color Schemes</legend>
		<input type="radio" name="scheme" value="blue"  '.  ($current == 'blue'   ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/scheme-blue.jpg"  alt="blue"    /> &nbsp;
		<input type="radio" name="scheme" value="red"   '.  ($current == 'red'    ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/scheme-red.jpg"   alt="red"     /> &nbsp;
		<input type="radio" name="scheme" value="green" '.  ($current == 'green'  ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/scheme-green.jpg" alt="green"   /> &nbsp;
		<input type="radio" name="scheme" value="pink" '.   ($current == 'pink'   ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/scheme-pink.jpg" alt="pink"     /> &nbsp;
		<input type="radio" name="scheme" value="purple" ' .($current == 'purple' ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/scheme-purple.jpg" alt="purple" /> &nbsp;
		<input type="radio" name="scheme" value="orange" ' .($current == 'orange' ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/scheme-orange.jpg" alt="orange" />  &nbsp;
		<input type="radio" name="scheme" value="teal"   ' .($current == 'teal'   ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/scheme-teal.jpg"   alt="teal"   /><br /><br />
		If you prefer to use your own header image with one of the color schemes, please consult the README page.<br /><br />
		<label><b>Background Color</b></label><br />
		<input type="text" name="bgcolor" value="'. $bgcolor .'" /><br />
		</fieldset>
<br />
		<fieldset class="options">
		<legend>Miscellaneous Options</legend>
		<label><b>Page Navigation Overlay</b></label><br />
                When enabled, this options overlays a translucent black stripe on the header for better readability.<br/><br/>
		<input type="radio" name="headoverlay" value="0"  '. ($headoverlay ? '' : 'checked="checked"') .' /><img src="'. get_bloginfo('template_directory') .'/option-headoverlay-off.jpg" alt="off" /> &nbsp;
		<input type="radio" name="headoverlay" value="1"  '. ($headoverlay ? 'checked="checked"' : '') .' /><img src="'. get_bloginfo('template_directory') .'/option-headoverlay-on.jpg"  alt="on"  /><br /><br />

		<label><b>Pages to Exclude from Header Navigation</b></label><br />
		'. $pages_select .'<br />

		<label><b>Readability</b></label><br/>
		<input type="checkbox" name="boldlinks" '. ($boldlinks ? 'checked="checked"' : '') .' /> Display all links in bold for better readability<br /><br />

		<label><b>Date Format</b></label><br/>
		<input type="radio" name="dates" value="0"  '. ($dates ? '' : 'checked="checked"') .' />dd/mm/yyyy &nbsp;
		<input type="radio" name="dates" value="1"  '. ($dates ? 'checked="checked"' : '') .' />month/dd/yyyy
		</fieldset>

		<p class="submit"><input type="submit" name="Submit" value="'.__('Update Options &raquo;','mandigo').'"/></p>
		</form>

		<h2 id="versioncheck">'.__('Version Checker','mandigo').'</h2>
		<iframe src="http://www.onehertz.com/cgi-bin/wordpress:versioncheck.pl?theme=Mandigo&amp;version='. $ct->version .'" width="100%" height="90" scrolling="auto" frameborder="0"></iframe>

		</div>
		';

		echo '
		<div id="preview" class="wrap">
		<h2 id="preview-post">Preview (updated when options are saved)</h2>
		<iframe src="../?preview=true" width="100%" height="600" ></iframe>
		</div>
		';
	}
}

function mandigo_readme_page() {
	echo '<div class="wrap">';
	echo '<pre>';
	include("README.txt");
	echo '</pre>';
	echo '</div>';
}
?>
